package com.example.demo_hlk;

import java.net.Socket;
import java.net.UnknownHostException;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetAddress;

import android.view.View.OnClickListener;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.SystemClock;
import android.app.Activity;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.util.Log;

import com.example.demo_hlk.R;
import com.example.demo_hlk.Utils;
import com.vveye.T2u;

public class TestActivity extends Activity implements OnClickListener,
		PrintInterface {
	static InetAddress serverAddr;
	static int port;
	public static Handler mainHandler;
	private String rxTextString = "";
	private Message message;
	public static EditText _txtReceive;
	public static EditText _txtSend;
	static Button btnConnect;

	Button btnIP;
	EditText _txtUUID;
	EditText _txtPwd;
	Button btnCancel;

	String strUUID;
	String strPwd;// 

	String StrSend;// 
	String StrReceive;// 

	Button btnClearReceive;
	Button btnSend;
	public static boolean blOK = true;// Ƿ

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setTitle("Switch Off");
		setContentView(R.layout.test);

		btnConnect = (Button) findViewById(R.id.test_submit);// Ӱť
		btnCancel = (Button) findViewById(R.id.test_cancel);// 
		btnIP = (Button) findViewById(R.id.test_LocalIP);// IP
		btnClearReceive = (Button) findViewById(R.id.test_clear);// ս
		btnSend = (Button) findViewById(R.id.test_send);// 

		btnConnect.setOnClickListener(this);
		btnCancel.setOnClickListener(this);
		btnIP.setOnClickListener(this);
		btnClearReceive.setOnClickListener(this);
		btnSend.setOnClickListener(this);
		_txtReceive = (EditText) findViewById(R.id.test_txtReceive);// 
		_txtSend = (EditText) findViewById(R.id.test_txtSend);// 
		_txtUUID = (EditText) findViewById(R.id.test_uuid);// UUID
		_txtPwd = (EditText) findViewById(R.id.test_password);// PWD
		initMainHandler();
		// ؼȡ
		enableButton(false);
	}

	// 
	void initMainHandler() {

		mainHandler = new Handler() {

			@Override
			// ߳Ϣ
			public void handleMessage(Message msg) {

				// ̵߳Ϣ
			}

		};

	}

	/**
	 * ıʾ
	 */
	public void printf(String str) {

		rxTextString += str + "\n";

		runOnUiThread(new Runnable() {
			public void run() {
				// TODO Auto-generated method stub
				_txtReceive.setText(rxTextString);

				// _textScrollView.scrollTo(0, _textScrollView.getHeight() +
				// 14);

			}
		});
	}

	// ر
	protected void onDestroy() {

		// ClientThread.childHandler.sendMessage(ClientThread.childHandler.obtainMessage(1));
		Log.d("Close", "close");
		btnConnect.setText("Connect");

		enableButton(false);

		setTitle("Close Connect");
		// رն˿
		if (port > 0)
			T2u.DelPort((char) port);
		// ͷԴ
		T2u.Exit();
		printf("Ͽ");

		super.onDestroy();
	}

	// ؼ
	public void enableButton(boolean blEnable) {
		btnSend.setClickable(blEnable);

	}

	@Override
	public void onClick(View v) {
		switch (v.getId()) {

		case R.id.test_submit:// 
			if (btnConnect.getText().equals("Connect")) {
				printf("...");

				if (P2PConnect()) {
					String strIP = Utils.getIPAddress(true);
					Log.i("IP", "IP:" + strIP + "," + "Port:" + port);
					try {
						serverAddr = InetAddress.getByName(strIP);
					} catch (UnknownHostException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					printf("ӳɹ");
					btnConnect.setText("Close");
					blOK = true;
					// ؼ
					enableButton(true);
				} else {
					// ؼ
					enableButton(false);
					printf("ʧ");
				}

			} else {
				blOK = false;
				onDestroy();
			}
			break;
		case R.id.test_LocalIP:// ȡIP
			String strMsg = Utils.getIPAddress(true);
			setTitle("IP:" + strMsg);
			break;
		case R.id.test_clear:// ս
			rxTextString = "";
			_txtReceive.setText("");
			break;
		case R.id.test_cancel:// UUID
			_txtUUID.setText("");
			_txtPwd.setText("");
			break;
		case R.id.test_send:
			// sendMessage(_txtSend.getText().toString());//Ϣ
			StrSend = _txtSend.getText().toString();
			new Thread(SendThread).start();

			break;
		}

	}

	// P2P
	// 
	private boolean P2PConnect() {
		int intWaitTime = 0;
		// ȡ豸ID
		EditText edit_text = (EditText) findViewById(R.id.test_uuid);// ı
		CharSequence edit_text_value = edit_text.getText();
		if (edit_text_value.length() == 0) {
			setTitle("uuid Is Null");
			return false;
		}
		strUUID = edit_text_value.toString();// 豸ID
		if (strUUID.length() == 0)
			return false;

		// ȡ豸ID
		EditText edit_text1 = (EditText) findViewById(R.id.test_password);// ı
		CharSequence edit_text_value1 = edit_text1.getText();
		if (edit_text_value1.length() == 0) {
			setTitle("password Is Null");
			return false;
		}
		strPwd = edit_text_value1.toString();// 
		if (strPwd.length() == 0)
			return false;

		// -------------SDKʼ------------------------
		try {
			T2u.Init("nat.vveye.net", (char) 8000, "");
		} catch (Exception e) {
			setTitle(" initial fail:" + e.toString());
			return false;
		}

		// ---------豸-------------------------
		byte[] result = new byte[1500];
		int num = T2u.Search(result);
		String tmp;
		setTitle("T2u.Search:" + num);
		if (num > 0) {
			tmp = new String(result);
			setTitle("Device:" + tmp);

		} else {
			setTitle("Local Device Search Fail");
		}
		// ----------------ȴ---------------------

		while (T2u.Status() == 0) {
			SystemClock.sleep(1000);
			intWaitTime += 1;

			setTitle("T2u.Status=" + T2u.Status());
			if (intWaitTime > 10) {
				break;
			}
		}

		setTitle("T2u.status -> " + T2u.Status());

		// ------------------- ض˿ӳ--------------------
		if (T2u.Status() == 1) {
			int ret;
			// ---------------ѯ豸Ƿ-----------------
			ret = T2u.Query(strUUID);
			setTitle("T2u.Query:" + strUUID + " -> " + ret);
			if (ret > 0) {
				// ******************IP*********************
				// String strIP = Utils.getIPAddress(true);
				// setTitle("IP:" + strIP);
				// --------------ӳ˿-----------------
				port = T2u.AddPortV3(strUUID, strPwd, "127.0.0.1", (char) 8080,
						(char) 0);
				setTitle("T2u.add_port -> port:" + port);

			} else {
				setTitle("Device is not on line");
				return false;
			}
		} else {
			setTitle("Server is not on line");
			return false;
		}
		// ж϶˿ںǷӳɹ
		if (!isNumeric(String.valueOf(port))) {
			return false;
		}
		// -------------------ӳɹ,ذťڻ״̬--------------------

		return true;
	}

	// JAVAԴĺ
	public static boolean isNumeric(String str) {
		for (int i = str.length(); --i >= 0;) {
			if (!Character.isDigit(str.charAt(i))) {
				return false;
			}
		}
		return true;
	}

	// ߳
	Runnable SendThread = new Runnable() {
		public void run() {
			Socket socket = null;
			try {
				socket = new Socket(serverAddr, port);

				OutputStream output = socket.getOutputStream();
				byte buffer[] = new byte[1024 * 4];
				int tmp = 0;

				InputStream input = new ByteArrayInputStream(StrSend.getBytes());

				while ((tmp = input.read(buffer)) != -1) {
					output.write(buffer, 0, tmp);
					printf(">>" + StrSend);
				}
				output.flush();
				long startTime = System.currentTimeMillis();
				long endTime = System.currentTimeMillis();
				System.out.println("Message has been sent");
				// ʱ
				long delayTime = endTime - startTime;
				while (delayTime < 5 * 1000) {
					InputStream in = socket.getInputStream();

					byte buffer1[] = new byte[1024];
					int tmp1 = 0;

					if ((tmp1 = in.read(buffer1)) != -1) {
						String content = new String(buffer1, 0, tmp1);
						System.out.println("receive: " + content);
						printf("<<" + content);
						in.close();
						break;

					}
					endTime = System.currentTimeMillis();
				}

			} catch (UnknownHostException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				try {
					socket.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

		}
	};

}
